﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Windows.Forms;
using System.Drawing;

namespace WindowsFormsApplication1
{
    class FileSystem
    {

        struct NodeInfo
        {
            public string portraitPath;
            public string iconPath;
            public string titlePath;
        }
        static BrawlLib.SSBB.ResourceNodes.ARCNode comFile = new BrawlLib.SSBB.ResourceNodes.ARCNode();
        static string lastLoadedComPath;
        static TreeNodeCollection simpleRoot;
        public static void Load(TreeNodeCollection nodes, TreeNodeCollection simpleNodes)
        {
            // XmlDocument doc = new XmlDocument();
            //doc.Load("brawlFileSystem.xml");
            simpleRoot = simpleNodes;
            XmlReader reader = XmlReader.Create("brawlFileSystem.xml");
            reader.Read();
            TreeNode root = null;// = new TreeNode();
            // nodes.Add(root);
            //int depth = 0;
            while (reader.Read())
            {
                reader.MoveToElement();

                if (reader.Name.CompareTo("Folder") == 0)
                {
                    if (reader.AttributeCount == 0)
                    {
                        root = root.Parent;
                    }
                    else
                    {

                        TreeNode newroot = new TreeNode(reader.GetAttribute("Name"));
                        if (root != null)
                            root.Nodes.Add(newroot);
                        else
                            nodes.Add(newroot);
                        root = newroot;
                    }
                }
                if (reader.Name.CompareTo("File") == 0)
                {
                    if (root == null)
                        nodes.Add(reader.GetAttribute("Name"));
                    else
                    {
                        TreeNode newNode = root.Nodes.Add(reader.GetAttribute("Name"));
                        NodeInfo info = new NodeInfo();
                        info.portraitPath = "";
                        if (reader.GetAttribute("portrait") != null)
                        {
                            info.portraitPath = reader.GetAttribute("portrait");
                        }
                        info.iconPath = "";
                        if (reader.GetAttribute("icon") != null)
                        {
                            info.iconPath = reader.GetAttribute("icon");
                        }
                        info.titlePath = "";
                        if (reader.GetAttribute("title") != null)
                        {
                            info.titlePath = reader.GetAttribute("title");
                        }
                        newNode.Tag = info;
                        if (reader.GetAttribute("simple") != null)
                            AddSimple(reader.GetAttribute("simple"), newNode.FullPath, newNode);

                    }

                }
            }
            reader.Close();


        }
        static void AddSimple(string path, string value, TreeNode realNode)
        {

            string[] paths = path.Split('/');
            value = '/' + value.Replace('\\', '/');
            string filename = value.Substring(value.LastIndexOf('/') + 1);
            TreeNodeCollection root = simpleRoot;

            for (int i = 0; i <= paths.Length; i++)
            {
                if (i == paths.Length)
                {
                    TreeNode newNode = new TreeNode(filename);
                    newNode.ToolTipText = value;
                    NodeInfo info = new NodeInfo();
                    NodeInfo realInfo = (NodeInfo)realNode.Tag;
                    info.portraitPath = realInfo.portraitPath;
                    info.iconPath = realInfo.iconPath;
                    info.titlePath = realInfo.titlePath;
                    newNode.Tag = info;
                    root.Add(newNode);
                    break;
                }

                else if (root[paths[i]] == null)
                {
                    root.Add(paths[i]).Name = paths[i];
                    root[root.Count - 1].ToolTipText = "simpleFolder";
                }
                root = root[paths[i]].Nodes;
            }


        }
        public static bool Common5Loaded()
        {
            string com5pac = Data.getMapping( "/system/common5_en.pac" );
            com5pac = Data.activeDirectory + com5pac;
            if( com5pac.Length > 0 )
            {
                return true;
            }
            return false;
        }
        public static Image GetPortrait(TreeNode node)
        {
            //Load Preview Images
            string path = ((NodeInfo)node.Tag).portraitPath;
            if(path != null && path.Length > 0)
            {
                string com5pac = Data.getMapping("/system/common5_en.pac");
                com5pac = Data.activeDirectory + com5pac;
                if (com5pac.Length > 0)
                {
                    if (lastLoadedComPath != com5pac)
                    {
                        lastLoadedComPath = com5pac;
                        comFile.Replace(com5pac);
                    }
                    BrawlLib.SSBB.ResourceNodes.TEX0Node portrait = (BrawlLib.SSBB.ResourceNodes.TEX0Node)comFile.FindChild(path, true);
                    Image output = null;
                    try
                    {
                        output = portrait.GetImage(0);
                    }
                    catch (Exception e)
                    {

                    }
                    //comFile.Dispose();
                    return output;
                }
            }
            return null;
        }

        public static Image GetIcon(TreeNode node)
        {
            //Load Preview Images
            string path = ((NodeInfo)node.Tag).iconPath;
            if (path != null && path.Length > 0)
            {
                string com5pac = Data.getMapping("/system/common5_en.pac");
                com5pac = Data.activeDirectory + com5pac;
                if (com5pac.Length > 0)
                {
                    if (lastLoadedComPath != com5pac)
                    {
                        lastLoadedComPath = com5pac;
                        comFile.Replace(com5pac);
                    }
                    BrawlLib.SSBB.ResourceNodes.TEX0Node portrait = (BrawlLib.SSBB.ResourceNodes.TEX0Node)comFile.FindChild(path, true);
                    Image output = portrait.GetImage(0);
                    //comFile.Dispose();
                    return output;
                }
            }
            return null;
        }
        public static Image GetTitle(TreeNode node)
        {
            //Load Preview Images
            string path = ((NodeInfo)node.Tag).titlePath;
            if (path != null && path.Length > 0)
            {
                string com5pac = Data.getMapping("/system/common5_en.pac");
                com5pac = Data.activeDirectory + com5pac;
                if (com5pac.Length > 0)
                {
                    if (lastLoadedComPath != com5pac)
                    {
                        lastLoadedComPath = com5pac;
                        comFile.Replace(com5pac);
                    }
                    BrawlLib.SSBB.ResourceNodes.TEX0Node portrait = (BrawlLib.SSBB.ResourceNodes.TEX0Node)comFile.FindChild(path, true);
                    Image output = portrait.GetImage(0);
                    //comFile.Dispose();
                    return output;
                }
            }
            return null;
        }
        public static void SetPortrait(TreeNode node)
        {
            TextureConverterDialog a = new TextureConverterDialog();
            
            BrawlLib.SSBB.ResourceNodes.TEX0Node oldTexture = (BrawlLib.SSBB.ResourceNodes.TEX0Node)comFile.FindChild(((NodeInfo)node.Tag).portraitPath, true);
            //a.ShowDialog(null, oldTexture);
            //oldTexture.Replace(((BrawlLib.Imaging.IImageSource)a.TextureData).GetImage(0));
            if (a.ShowDialog(null, oldTexture) == DialogResult.OK)
            comFile.Export(lastLoadedComPath);
        }
        public static void SetIcon(TreeNode node)
        {
            TextureConverterDialog a = new TextureConverterDialog();

            BrawlLib.SSBB.ResourceNodes.TEX0Node oldTexture = (BrawlLib.SSBB.ResourceNodes.TEX0Node)comFile.FindChild(((NodeInfo)node.Tag).iconPath, true);
            //oldTexture.Replace(((BrawlLib.Imaging.IImageSource)a.TextureData).GetImage(0));
            if(a.ShowDialog(null, oldTexture) == DialogResult.OK)
            comFile.Export(lastLoadedComPath);
        }
        public static void SetTitle(TreeNode node)
        {
            TextureConverterDialog a = new TextureConverterDialog();

            BrawlLib.SSBB.ResourceNodes.TEX0Node oldTexture = (BrawlLib.SSBB.ResourceNodes.TEX0Node)comFile.FindChild(((NodeInfo)node.Tag).titlePath, true);
            //a.ShowDialog(null, oldTexture);
            //oldTexture.Replace(((BrawlLib.Imaging.IImageSource)a.TextureData).GetImage(0));
            if (a.ShowDialog(null, oldTexture) == DialogResult.OK)
            comFile.Export(lastLoadedComPath);
        }
    }
}
