﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;


namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        
        string lastRiivolutionPath = "";
        string lastFilePath = "";
        public Form1()
        {
            InitializeComponent();
        }

        private void treeViewFiles_AfterSelect(object sender, TreeViewEventArgs e)
        {
            TreeNode node = treeViewFiles.SelectedNode;
            if (node.GetNodeCount(false) > 0)
            {
                textBoxFilePath.Text = Data.fullPathFix(node);
                textBoxReplaceFile.Text = Data.getMapping(textBoxFilePath.Text + "\\");
            }
            else
            {
                textBoxFilePath.Text = Data.fullPathFix(node);
                textBoxReplaceFile.Text = Data.getMapping(textBoxFilePath.Text);
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Data.Init();
            FileSystem.Load(treeViewFiles.Nodes, treeViewSimple.Nodes);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (treeViewFiles.SelectedNode != null)
            {
                if (treeViewFiles.SelectedNode.GetNodeCount(false) > 0)
                {
                    FolderBrowserDialog ofd = new FolderBrowserDialog();
                    ofd.ShowDialog();
                    if (ofd.SelectedPath.Length > 0)
                    {
                        //textBoxReplaceFile.Text = ofd.SelectedPath.Substring(2);
                        Data.setMapping(Data.fullPathFix(treeViewFiles.SelectedNode) + "\\", ofd.SelectedPath.Substring(2));
                        textBoxReplaceFile.Text = Data.getMapping(Data.fullPathFix(treeViewFiles.SelectedNode) + "\\");
                        Data.activateMapping(Data.fullPathFix(treeViewFiles.SelectedNode) + "\\", true);
                        treeViewFiles.SelectedNode.Checked = true;
                    }
                    ofd.Dispose();
                }
                else
                {
                    string ext = treeViewFiles.SelectedNode.Text.Substring(treeViewFiles.SelectedNode.Text.IndexOf('.'));

                    OpenFileDialog ofd = new OpenFileDialog();
                    //ofd.InitialDirectory = lastFilePath;
                    ofd.Filter = ext + "|*" + ext;
                    ofd.ShowDialog();
                    if (ofd.FileName.Length > 0)
                    {
                        //textBoxReplaceFile.Text = ofd.FileName.Substring(2);
                        Data.setMapping(Data.fullPathFix(treeViewFiles.SelectedNode), ofd.FileName);
                        textBoxReplaceFile.Text = Data.getMapping(Data.fullPathFix(treeViewFiles.SelectedNode));
                        Data.activateMapping(Data.fullPathFix(treeViewFiles.SelectedNode), true);
                        treeViewFiles.SelectedNode.Checked = true;
                        //lastFilePath = System.IO.Path.GetDirectoryName(ofd.FileName);
                    }
                    ofd.Dispose();
                }
            }
        }
        private void treeViewFiles_BeforeCheck(object sender, TreeViewCancelEventArgs e)
        {
            if (e.Action == TreeViewAction.Unknown) return;
            TreeNode node = e.Node;
            if (node.GetNodeCount(false) > 0)
            {

                if (Data.getMapping(Data.fullPathFix(node) + "\\").Length == 0)
                {
                    e.Cancel = true;
                    //node.Checked = false;

                    return;
                }
            }
            else
            {
                if (Data.getMapping(Data.fullPathFix(node)).Length == 0)
                {
                    e.Cancel = true;
                    //node.Checked = false;
                    return;
                }
            }
        }
        private void treeViewFiles_AfterCheck(object sender, TreeViewEventArgs e)
        {
            
            if (e.Action == TreeViewAction.Unknown) return;
            TreeNode node = e.Node;
            if (node.GetNodeCount(false) > 0)
            {
                Data.activateMapping(Data.fullPathFix(node) + "\\", node.Checked);

            }
            else
            {
                Data.activateMapping(Data.fullPathFix(node), node.Checked);
            }
        }

        private void saveRiivolutionXMLToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Filter = "Riivolution XML(*.xml)|*.xml";
            sfd.ShowDialog();
            if (sfd.FileName.Length > 0)
                Data.SaveXml(sfd.FileName);
            sfd.Dispose();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (treeViewFiles.SelectedNode != null)
            {
                if (treeViewFiles.SelectedNode.GetNodeCount(false) > 0)
                    Data.setMapping(Data.fullPathFix(treeViewFiles.SelectedNode) + "\\", null);
                else
                    Data.setMapping(Data.fullPathFix(treeViewFiles.SelectedNode), null);
                Data.activateMapping(Data.fullPathFix(treeViewFiles.SelectedNode), false);
                textBoxReplaceFile.Text = "";
                checkNodes(treeViewFiles.Nodes[0]);
            }
        }

        private void openRiivolutionXMLToolStripMenuItem_Click(object sender, EventArgs e)
        {
            

            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "Riivolution XML(*.xml)|*.xml";
            ofd.ShowDialog();
            if (ofd.FileName.Length > 0)
            {
                //uncheckNodes(treeViewFiles.Nodes[0]);
                Data.LoadXml(ofd.FileName);
                checkNodes(treeViewFiles.Nodes[0]);
                checkSimpleNodes(treeViewSimple.Nodes[0]);
                textBoxReplaceFile.Text = Data.getMapping(Data.fullPathFix(treeViewFiles.SelectedNode));
                updateCustomXMLDisplay();
                textBoxGCTFile.Text = Data.gctPath;
                checkBoxOcarina.Checked = Data.ocarinaEnabled;
                lastRiivolutionPath = ofd.FileName;
            }
            ofd.Dispose();
            if( FileSystem.Common5Loaded() )
                Common5Warning.Hide();
            else
                Common5Warning.Show();
        }
        private void uncheckNodes(TreeNode node)
        {
            if (node.GetNodeCount(false) > 0)
            {
                node.Checked = false;
                checkNodes(node.Nodes[0]);
            }
            else
                node.Checked = false;
            if (node.NextNode != null)
                checkNodes(node.NextNode);
        }
        private void checkNodes(TreeNode node)
        {
            if (node.Checked)
            {
                int a = 23;
            }
            node.Checked = false;
            if (node.GetNodeCount(false) > 0)
            {
                if (Data.isActive(Data.fullPathFix(node) + "\\"))
                    node.Checked = true;
                checkNodes(node.Nodes[0]);
            }
            else if (Data.isActive(Data.fullPathFix(node))) 
                    node.Checked = true;
            if (node.NextNode != null)
                checkNodes(node.NextNode);

        }
        private void checkSimpleNodes(TreeNode node)
        {
            node.Checked = false;
            if (node.GetNodeCount(false) > 0)
            {
                checkSimpleNodes(node.Nodes[0]);
                if (node.Checked && node.Parent != null)
                    node.Parent.Checked = true;
            }
            else if (Data.isActive(node.ToolTipText))
            {
                node.Checked = true;
                if (node.Parent != null)
                    node.Parent.Checked = true;
            }
            if (node.NextNode != null)
                checkSimpleNodes(node.NextNode);

        }

        private void helpToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Use this program to build a Riivolution XML for mapping files from the brawl disc, to replacement files on your SD card or USB drive.\nFirst you want to put your custom content onto your external device, organized however you like.\nThen find the files you want to replace in the file tree. Once you click on one, you can hit browse and choose your custom file to replace it with when running Riivolution! \nYou will need to click in the checkmark box for the replacement to be active. Once you have it setup the way you want, choose save Riivolution XML, and save the file on your external device under the Riivolution folder.\n\nTo replace Character Select Portraits(CSPs), you'll need to add the COMMON5.pac file(Under thee All Files tab/System), then the portraits and stage icons will show up correctly. Click on the box to change to your own file. All changes are saved into your COMMON5.pac immediately, independently of your saving the XML file.\nMade by Agoaj\nwww.agoaj.com");
        }












        /// <summary>
        /// Adds basic coloured syntax to the text in a RichTextBox - By Alun Evans 
        /// http://www.codeproject.com/KB/cs/RTFSyntaxColour.aspx
        /// </summary>
        private void AddColouredText(string strTextToAdd)
        {
            if (strTextToAdd != null && strTextToAdd.Length > 0)
            {
                //Use the RichTextBox to create the initial RTF code
                richTextBox1.Clear();
                richTextBox1.AppendText(strTextToAdd);
                string strRTF = richTextBox1.Rtf;
                richTextBox1.Clear();

                /* 
                 * ADD COLOUR TABLE TO THE HEADER FIRST 
                 * */

                // Search for colour table info, if it exists (which it shouldn't)
                // remove it and replace with our one
                int iCTableStart = strRTF.IndexOf("colortbl;");

                if (iCTableStart != -1) //then colortbl exists
                {
                    //find end of colortbl tab by searching
                    //forward from the colortbl tab itself
                    int iCTableEnd = strRTF.IndexOf('}', iCTableStart);
                    strRTF = strRTF.Remove(iCTableStart, iCTableEnd - iCTableStart);

                    //now insert new colour table at index of old colortbl tag
                    strRTF = strRTF.Insert(iCTableStart,
                        // CHANGE THIS STRING TO ALTER COLOUR TABLE
                        "colortbl ;\\red255\\green0\\blue0;\\red0\\green128\\blue0;\\red0\\green0\\blue255;}");
                }

                //colour table doesn't exist yet, so let's make one
                else
                {
                    // find index of start of header
                    int iRTFLoc = strRTF.IndexOf("\\rtf");
                    // get index of where we'll insert the colour table
                    // try finding opening bracket of first property of header first                
                    int iInsertLoc = strRTF.IndexOf('{', iRTFLoc);

                    // if there is no property, we'll insert colour table
                    // just before the end bracket of the header
                    if (iInsertLoc == -1) iInsertLoc = strRTF.IndexOf('}', iRTFLoc) - 1;

                    // insert the colour table at our chosen location                
                    strRTF = strRTF.Insert(iInsertLoc,
                        // CHANGE THIS STRING TO ALTER COLOUR TABLE
                        "{\\colortbl ;\\red128\\green0\\blue0;\\red0\\green128\\blue0;\\red0\\green0\\blue255;}");
                }

                /*
                 * NOW PARSE THROUGH RTF DATA, ADDING RTF COLOUR TAGS WHERE WE WANT THEM
                 * In our colour table we defined:
                 * cf1 = red  
                 * cf2 = green
                 * cf3 = blue             
                 * */

                for (int i = 0; i < strRTF.Length; i++)
                {
                    if (strRTF[i] == '<')
                    {
                        //add RTF tags after symbol 
                        //Check for comments tags 
                        if (strRTF[i + 1] == '!')
                            strRTF = strRTF.Insert(i + 2, "\\cf2 ");
                        else
                            strRTF = strRTF.Insert(i + 1, "\\cf1 ");
                        //add RTF before symbol
                        strRTF = strRTF.Insert(i, "\\cf3 ");

                        //skip forward past the characters we've just added
                        //to avoid getting trapped in the loop
                        i += 6;
                    }
                    else if (strRTF[i] == '>')
                    {
                        //add RTF tags after character
                        strRTF = strRTF.Insert(i + 1, "\\cf0 ");
                        //Check for comments tags
                        if (strRTF[i - 1] == '-')
                        {
                            strRTF = strRTF.Insert(i - 2, "\\cf3 ");
                            //skip forward past the 6 characters we've just added
                            i += 8;
                        }
                        else
                        {
                            strRTF = strRTF.Insert(i, "\\cf3 ");
                            //skip forward past the 6 characters we've just added
                            i += 6;
                        }
                    }
                }
                richTextBox1.Rtf = strRTF;
            }
        }
        bool textColoring = false;
        private void richTextBox1_TextChanged(object sender, EventArgs e)
        {
            if (textColoring == false)
            {
                textColoring = true;
                int textSelection = richTextBox1.SelectionStart;
                AddColouredText(richTextBox1.Text);
                richTextBox1.SelectionStart = textSelection;
                Data.rawCustomXML = richTextBox1.Text;
            }
            textColoring = false;
        }

        private void updateCustomXMLDisplay()
        {
            richTextBox1.Text = Data.rawCustomXML;
        }

        private void tabControl1_Click(object sender, EventArgs e)
        {
            checkNodes(treeViewFiles.Nodes[0]);
            checkSimpleNodes(treeViewSimple.Nodes[0]);
            if (tabControl1.SelectedTab.Text.CompareTo("Custom XML") == 0)
                updateCustomXMLDisplay();
        }

        private void buttongctBrowse_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "*.gct|*.gct";
            ofd.ShowDialog();
            if (ofd.FileName.Length > 0)
            {
                Data.gctPath = ofd.FileName;
                Data.gctPath = Data.gctPath.Substring(Data.gctPath.IndexOf(':') + 1);
                Data.gctPath = Data.gctPath.Replace('\\', '/');
                textBoxGCTFile.Text = Data.gctPath;
                checkBoxOcarina.Checked = true;
            }
        }

        private void checkBoxOcarina_CheckedChanged(object sender, EventArgs e)
        {
            Data.ocarinaEnabled = checkBoxOcarina.Checked;
        }

        private void treeViewFiles_DoubleClick(object sender, EventArgs e)
        {

        }

        private void treeViewSimple_BeforeSelect(object sender, TreeViewCancelEventArgs e)
        {
            if (e.Node.ToolTipText.CompareTo("simpleFolder") == 0)
            {
                e.Cancel = true;
                if (e.Action != TreeViewAction.Unknown)
                {
                    e.Node.Expand();
                    if (e.Action == TreeViewAction.ByKeyboard)
                        treeViewSimple.SelectedNode = e.Node.Nodes[0];
                }
            }
        }

        private void treeViewSimple_BeforeCheck(object sender, TreeViewCancelEventArgs e)
        {
            if (e.Action != TreeViewAction.Unknown && e.Node.ToolTipText.CompareTo("simpleFolder") == 0) e.Cancel = true;
            if (e.Action != TreeViewAction.Unknown && Data.getMapping(e.Node.ToolTipText).Length == 0) e.Cancel = true;
        }

        private void treeViewSimple_AfterSelect(object sender, TreeViewEventArgs e)
        {
            TreeNode node = e.Node;
            textBoxFilePath.Text = e.Node.ToolTipText;
            textBoxSimpleExternal.Text = Data.getMapping(textBoxFilePath.Text);
            pictureBox_Portrait.Image = FileSystem.GetPortrait(node);
            pictureBox_Icon.Image = FileSystem.GetIcon(node);
            pictureBox_Title.Image = FileSystem.GetTitle(node);

            if( FileSystem.Common5Loaded() )
                Common5Warning.Hide();
            else
                Common5Warning.Show();

        }

        private void buttonSimpleBrowse_Click(object sender, EventArgs e)
        {
            if (treeViewSimple.SelectedNode == null) return;
            string ext = treeViewSimple.SelectedNode.ToolTipText.Substring(treeViewSimple.SelectedNode.ToolTipText.IndexOf('.'));

            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = ext + "|*" + ext;
            ofd.ShowDialog();
            if (ofd.FileName.Length > 0)
            {
                //textBoxReplaceFile.Text = ofd.FileName.Substring(2);
                Data.setMapping(treeViewSimple.SelectedNode.ToolTipText, ofd.FileName.Substring(2));
                textBoxSimpleExternal.Text = Data.getMapping(treeViewSimple.SelectedNode.ToolTipText);
                Data.activateMapping(treeViewSimple.SelectedNode.ToolTipText, true);
                checkSimpleNodes(treeViewSimple.Nodes[0]);
                //treeViewSimple.SelectedNode.Checked = true;
            }

        }

        private void treeViewSimple_AfterCheck(object sender, TreeViewEventArgs e)
        {
            if (e.Action == TreeViewAction.Unknown) return;
            Data.activateMapping(e.Node.ToolTipText, e.Node.Checked);
        }

        private void buttonSimpleRemove_Click(object sender, EventArgs e)
        {

            Data.activateMapping(treeViewSimple.SelectedNode.ToolTipText, false);
            Data.setMapping(treeViewSimple.SelectedNode.ToolTipText, null);
            treeViewSimple.SelectedNode.Checked = false;
            textBoxSimpleExternal.Text = "";
            checkSimpleNodes(treeViewSimple.Nodes[0]);

        }

        private void pictureBox_Portrait_Click(object sender, EventArgs e)
        {
            if(pictureBox_Portrait.Image == null) return;
            

            //pictureBox_Portrait.Image = a.TextureNode.GetImage(0);
            FileSystem.SetPortrait(treeViewSimple.SelectedNode);
            pictureBox_Portrait.Image = FileSystem.GetPortrait(treeViewSimple.SelectedNode); //This will only work with simple nodes...
        }

        private void pictureBox_Title_Click(object sender, EventArgs e)
        {
            if (pictureBox_Title.Image == null) return;
            FileSystem.SetTitle(treeViewSimple.SelectedNode);
            pictureBox_Title.Image = FileSystem.GetTitle(treeViewSimple.SelectedNode); //This will only work with simple nodes...
        }

        private void pictureBox_Icon_Click(object sender, EventArgs e)
        {
            if (pictureBox_Icon.Image == null) return;
            FileSystem.SetIcon(treeViewSimple.SelectedNode);
            pictureBox_Icon.Image = FileSystem.GetIcon(treeViewSimple.SelectedNode); //This will only work with simple nodes...
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Data.SaveXml(lastRiivolutionPath);
        }


    }
}
